config/routes.rb
Rails.application.routes.draw do
  root 'chats#index'
  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'
  resources :messages, only: [:create]

  mount ActionCable.server, at: '/cable'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/message.rb
class Message < ApplicationRecord
  validates :body, presence: true
  belongs_to :user

  scope :custom_display, -> { order(:created_at).last(30) }
end

app/models/user.rb
class User < ApplicationRecord
  validates :username, presence: true, uniqueness: { case_sensitive: false }, length: {minimum: 3, maximum: 15}
  has_secure_password
  has_many :messages
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  helper_method :current_user, :logged_in?

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end

  def logged_in?
    !!current_user
  end

  def authorize_user
    if !logged_in?
      flash[:alert] = "You must logged in!!"
      redirect_to login_path
    end
  end
end

app/controllers/chats_controller.rb
class ChatsController < ApplicationController
  before_action :authorize_user

  def index
    @message = Message.new
    @messages = Message.custom_display
    @users = User.all
  end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  before_action :authorize_user

  def create
    message = current_user.messages.new(message_params)
    if message.save
      ActionCable.server.broadcast "chat_channel", message_body: message_render(message)
    end
  end

  private

  def message_params
    params.require(:message).permit(:body)
  end

  def message_render(message)
    render(partial: 'message', locals: {message: message})
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  before_action :restrict_login, only: [:new, :create]

  def new
  end

  def create
    user = User.find_by(username: params[:session][:username])
    if user && user.authenticate(params[:session][:password])
      session[:user_id] = user.id
      flash[:success] = 'Successfully logged'
      redirect_to root_path
    else
      flash[:error] = 'Something went wrong!!'
      render 'new'
    end
  end

  def destroy
    session[:user_id] = nil
    flash[:success] = 'Successfully logged out!!'
    redirect_to login_path
  end

  private

  def restrict_login
    if logged_in?
      flash[:error] = "You are already logged in!!"
      redirect_to root_path
    end
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/chats/index.html.erb
<h2 class="ui center aligned large icon header">
  <%= image_tag("logo.png", class: "ui circular image") %>
  <p>Write something </P>
</h2>

<div class="ui two column grid">
  <div class="twelve wide column">
    <div class="ui fluid raised card chatbox"> 
      <div class="content" id="messages">
        <div class="ui feed" id="message-container">
          <% @messages.each do |message| %>
            <div class="event">
              <div class="content">
                <div class="summary">
                  <em><%= message.user.username if message.user %></em>:  <%= message.body %>
                </div>
              </div>
            </div>
          <% end %>
        </div>
      </div>
      <div class="extra content">
        <%= form_with(model: @message, class: "ui reply form") do |form| %>
          <div class="field">
            <div class="ui fluid icon input">
              <%= form.text_field :body, placeholder: "Enter text here.." %>
              <%= form.button '<i class="bordered inverted orange edit icon"></i>'.html_safe %>
            </div>
          </div>
        <% end %>
      </div>
    </div>
  </div>

  <div class="four wide column">
    <div class="ui fluid raised card chatbox"> 
      <div class="content">
        <div class="ui vertical menu">
          <a class="active item">
            Users
          </a>
          <% @users.each do |user| %>
            <a class="item">
              <%= user.username %>
            </a>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/layouts/_flash_messages.html.erb
<% flash.each do |name, message| %>
  <div class="ui <%= name %> message transition">
    <i class="close icon"></i>
    <div class="header">
      <%= message %>
    </div>
  </div>
<% end %>

app/views/layouts/_navigation.html.erb
<div class="ui small menu">
  <div class="ui container">
    <%= link_to 'Chats', root_path, class: "active item" %>
    <div class="right menu">
      <div class="ui dropdown item">
        Account <i class="dropdown icon"></i>
        <div class="menu">
          <% if logged_in? %>
            <%= link_to 'Log out', logout_path, class: "item", method: :delete %>
          <% else %>
            <%= link_to 'Log in', login_path, class: "item" %> 
            <%= link_to 'Sign up', "#", class: 'item' %>
          <% end %>
        </div>
      </div>
      <% unless logged_in? %>
        <div class="item">
          <%= link_to "Log in", login_path, class: "ui primary button" %>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>VChat</title>
    <%= favicon_link_tag %>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <div class="ui container">
      <%= render 'layouts/flash_messages' %>
      <%= yield %>
    </div>
  </body>
</html>

app/views/messages/_message.html.erb
<div class="event">
  <div class="content">
    <div class="summary">
      <em><%= message.user.username if message.user %></em>:  <%= message.body %>
    </div>
  </div>
</div>